IF (WIN32)
   SET (FLTK_POSSIBLE_INCLUDE_PATHS $ENV{SYSTEMDRIVE}/* $ENV{ProgramFiles}/* $ENV{ProgramW6432}/*)
   SET (FLTK_POSSIBLE_LIB_PATHS $ENV{SYSTEMDRIVE}/*/lib $ENV{ProgramFiles}/*/lib $ENV{ProgramW6432}/*/lib)
ELSE (WIN32)
   SET (FLTK_POSSIBLE_INCLUDE_PATHS $ENV{HOME}/local/include /usr/local/include /usr/include /usr/include/fltk-1)
   SET (FLTK_POSSIBLE_LIB_PATHS $ENV{HOME}/local/lib /usr/local/lib /usr/lib /usr/lib/* /usr/lib/fltk-1)
ENDIF (WIN32)

FIND_PATH(FLTK_INCLUDE_DIR FL/Fl.H ${FLTK_POSSIBLE_INCLUDE_PATHS})
FIND_LIBRARY(FLTK_LIBRARY NAMES fltk fltkd PATHS ${FLTK_POSSIBLE_LIB_PATHS})
FIND_LIBRARY(FLTK_LIBRARY_IMAGES NAMES fltkimages fltkimagesd fltk_images PATHS ${FLTK_POSSIBLE_LIB_PATHS})
IF (WIN32)
   FIND_LIBRARY(FLTK_LIBRARY_JPEG NAMES fltkjpeg fltkjpegd PATHS ${FLTK_POSSIBLE_LIB_PATHS})
   FIND_LIBRARY(FLTK_LIBRARY_PNG NAMES fltkpng fltkpngd PATHS ${FLTK_POSSIBLE_LIB_PATHS})
   FIND_LIBRARY(FLTK_LIBRARY_ZLIB NAMES zlib zlibd PATHS ${FLTK_POSSIBLE_LIB_PATHS})
ENDIF(WIN32)

IF (FLTK_INCLUDE_DIR AND FLTK_LIBRARY)
   SET(FLTK_FOUND TRUE)
   SET(FLTK_LIBRARIES ${FLTK_LIBRARY} ${FLTK_LIBRARY_IMAGES} ${FLTK_LIBRARY_JPEG} ${FLTK_LIBRARY_PNG} ${FLTK_LIBRARY_ZLIB})
ENDIF (FLTK_INCLUDE_DIR AND FLTK_LIBRARY)

IF (FLTK_FOUND)
   IF (NOT FLTK_FIND_QUIETLY)
      MESSAGE(STATUS "Found FLTK: ${FLTK_LIBRARY}")
   ENDIF (NOT FLTK_FIND_QUIETLY)
ELSE (FLTK_FOUND)
   IF (FLTK_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find FLTK")
   ENDIF (FLTK_FIND_REQUIRED)
ENDIF (FLTK_FOUND)
