IF (WIN32)
   SET (SPTK_POSSIBLE_INCLUDE_PATHS
        $ENV{SystemDrive}/SPTK/include
        $ENV{ProgramFiles}/SPTK/include
        $ENV{ProgramW6432}/SPTK/include
        "$ENV{SystemDrive}/Program Files/*/include")
   SET (SPTK_POSSIBLE_LIB_PATHS
        $ENV{SystemDrive}/SPTK/lib
        $ENV{ProgramFiles}/SPTK/lib
        $ENV{ProgramW6432}/SPTK/lib
        "$ENV{SystemDrive}/Program Files/*/LIB")
   SET (SPTK_POSSIBLE_SHARE_PATHS
        $ENV{SystemDrive}/SPTK/share
        $ENV{ProgramFiles}/SPTK/share
        $ENV{ProgramW6432}/SPTK/share
        "$ENV{SystemDrive}/Program Files/*/share")
ELSE (WIN32)
   SET (SPTK_POSSIBLE_INCLUDE_PATHS
        /usr/include
        /usr/local/include)
   SET (SPTK_POSSIBLE_LIB_PATHS
        /usr/lib64
        /usr/lib
        /usr/local/lib)
ENDIF (WIN32)

FIND_PATH(SPTK_INCLUDE_DIR sptk5/sptk.h ${SPTK_POSSIBLE_INCLUDE_PATHS})
FIND_LIBRARY(SPTK_LIBRARY NAMES sputil5 PATHS ${SPTK_POSSIBLE_LIB_PATHS})
FIND_LIBRARY(SPTK_DB_LIBRARY NAMES spdb5 PATHS ${SPTK_POSSIBLE_LIB_PATHS})
FIND_LIBRARY(SPTK_WSDL_LIBRARY NAMES spwsdl5 PATHS ${SPTK_POSSIBLE_LIB_PATHS})

IF (WIN32)
    FIND_PATH(SPTK_SHARE_DIR sptk5/resources/events.rc ${SPTK_POSSIBLE_SHARE_PATHS})
ENDIF (WIN32)

#MESSAGE(${SPTK_INCLUDE_DIR})
#MESSAGE(${SPTK_LIBRARY})

IF (SPTK_INCLUDE_DIR AND SPTK_LIBRARY)
   SET(SPTK_FOUND TRUE)
ENDIF (SPTK_INCLUDE_DIR AND SPTK_LIBRARY)

IF (SPTK_INCLUDE_DIR AND SPTK_DB_LIBRARY)
   SET(SPTK_DB_FOUND TRUE)
ENDIF (SPTK_INCLUDE_DIR AND SPTK_DB_LIBRARY)

IF (SPTK_INCLUDE_DIR AND SPTK_WSDL_LIBRARY)
   SET(SPTK_WSDL_FOUND TRUE)
ENDIF (SPTK_INCLUDE_DIR AND SPTK_WSDL_LIBRARY)

IF (SPTK_FOUND)
   IF (NOT SPTK_FIND_QUIETLY)
      MESSAGE(STATUS "Found SPTK: ${SPTK_LIBRARY}")
   ENDIF (NOT SPTK_FIND_QUIETLY)
ELSE (SPTK_FOUND)
   IF (SPTK_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find SPTK")
   ENDIF (SPTK_FIND_REQUIRED)
ENDIF (SPTK_FOUND)

IF (SPTK_DB_FOUND)
   IF (NOT SPTK_FIND_QUIETLY)
      MESSAGE(STATUS "Found SPTK DB support: ${SPTK_DB_LIBRARY}")
   ENDIF (NOT SPTK_FIND_QUIETLY)
ELSE (SPTK_DB_FOUND)
   IF (SPTK_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find SPTK DB support")
   ENDIF (SPTK_FIND_REQUIRED)
ENDIF (SPTK_DB_FOUND)
